Object subclass: #LOR
	instanceVariableNames: 'reference hostip hostport classname oid marshalledForm '
	classVariableNames: 'Lastoid Separator SeparatorChar '
	poolDictionaries: ''
	category: 'Network-Remote message passing'!

!LOR methodsFor: 'accessing' stamp: 'JF 7/4/2000 10:26'!
classname
	^ classname! !

!LOR methodsFor: 'accessing' stamp: 'JF 7/4/2000 10:26'!
classname: aString
	classname _ aString! !

!LOR methodsFor: 'accessing' stamp: 'JF 7/4/2000 09:15'!
hostip

	^ hostip! !

!LOR methodsFor: 'accessing' stamp: 'JF 7/4/2000 09:15'!
hostip: aString

	hostip _ aString! !

!LOR methodsFor: 'accessing' stamp: 'JF 7/4/2000 09:15'!
hostport

	^ hostport! !

!LOR methodsFor: 'accessing' stamp: 'JF 7/4/2000 09:15'!
hostport: aString

	hostport _ aString! !

!LOR methodsFor: 'accessing' stamp: 'JF 7/27/2000 16:47'!
marshalledForm
	^marshalledForm! !

!LOR methodsFor: 'accessing' stamp: 'JF 7/27/2000 16:47'!
marshalledForm: aString
	marshalledForm _ aString! !

!LOR methodsFor: 'accessing' stamp: 'JF 7/4/2000 09:19'!
oid
	^ oid! !

!LOR methodsFor: 'accessing' stamp: 'JF 7/4/2000 09:19'!
oid: anID
	
	oid _ anID! !

!LOR methodsFor: 'accessing' stamp: 'JF 7/3/2000 17:35'!
reference
	^ reference! !

!LOR methodsFor: 'accessing' stamp: 'JF 7/3/2000 17:35'!
reference: aRef
	reference _ aRef! !


!LOR methodsFor: 'converting' stamp: 'JF 7/31/2000 15:52'!
marshal

	self marshalledForm ifNil: [
		self marshalledForm:
			(self hostip , Separator ,
			(self hostport asString) , Separator ,
			(self oid asString)  , Separator ,
			(self classname))].

	^ self marshalledForm! !


!LOR methodsFor: 'comparing' stamp: 'JF 7/4/2000 17:59'!
= aLOR

	^ (self oid = aLOR oid) and:
		[(self hostip = aLOR hostip) and:
			[self hostport = aLOR hostport]]! !

!LOR methodsFor: 'comparing' stamp: 'JF 7/4/2000 18:18'!
hash
	^ self oid! !


!LOR methodsFor: 'printing' stamp: 'JF 7/6/2000 15:19'!
printOn: aStream
	"Print out ip, port, oid and class"
	
	super printOn: aStream.
	aStream nextPutAll:
		('(', self hostip , ':',
		(self hostport asString) , ' => ' ,
		(self oid asString)  , ', ',
		((self classname at: 1) isVowel ifTrue: ['an '] ifFalse: ['a ']) ,
		(self classname), ')').! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

LOR class
	instanceVariableNames: ''!

!LOR class methodsFor: 'initialize-release' stamp: 'JF 7/5/2000 18:55'!
initialize
	Lastoid _ 0.
	Separator _ String tab.
	SeparatorChar _ Character tab! !


!LOR class methodsFor: 'instance creation' stamp: 'JF 7/3/2000 17:39'!
new
	^ self shouldNotImplement! !

!LOR class methodsFor: 'instance creation' stamp: 'JF 7/4/2000 11:22'!
to: anObject
	|instance|
	instance _ self basicNew.
	instance hostip: NetNameResolver localAddressString.
	instance hostport: ORB current port.
	instance classname: anObject class name asString.
	Lastoid _ Lastoid + 1.
	instance oid: Lastoid.
	^ instance.
! !

!LOR class methodsFor: 'instance creation' stamp: 'JF 7/18/2000 17:09'!
to: anObject withID: anID
	|instance|
	instance _ self basicNew.
	instance hostip: NetNameResolver localAddressString.
	instance hostport: ORB current port.
	instance classname: anObject class name asString.
	instance oid: anID.
	^ instance.
! !

!LOR class methodsFor: 'instance creation' stamp: 'JF 7/18/2000 17:44'!
toHost: anIP withPort: aPort andID: anID
	|instance|
	instance _ self basicNew.
	instance hostip: anIP.
	instance hostport: aPort.
	instance classname: 'aService'.
	instance oid: anID.
	^ instance.
! !

!LOR class methodsFor: 'instance creation' stamp: 'JF 7/27/2000 16:49'!
unmarshal: aString
	| instance tokens |

	instance _ self basicNew.
	tokens _ aString findTokens: (Array with: SeparatorChar).
	instance hostip: (tokens at: 1).
	instance hostport: (Integer readFrom: (ReadStream on: (tokens at: 2))).
	instance oid: (Integer readFrom: (ReadStream on: (tokens at: 3))).
	instance classname: (tokens at: 4).
	instance marshalledForm: aString.
	^ instance! !


Object subclass: #Marshaller
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Network-Remote message passing'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Marshaller class
	instanceVariableNames: ''!

!Marshaller class methodsFor: 'marshalling' stamp: 'JF 9/11/2000 16:16'!
marshal: anObject withORB: anORB
	"We pass Integers, Strings, Characters, Booleans, nil, Symbols by copy.
	(Must pass Booleans by copy, otherwise inspect it and print it dont work)"

	"First line is an optimisation"
	(anObject isKindOf: NetworkStub) ifTrue: [^ 'O' ,  anObject xxxJFStubObjectReference marshal].
	(anObject isMemberOf: Symbol) ifTrue: [^ 'Y', anObject asString].
	(anObject isMemberOf: String) ifTrue: [^ 'S' , anObject].
	(anObject isInteger) ifTrue: [^ 'I' , anObject asString].
	(anObject isMemberOf: Character) ifTrue: [^ 'C' , anObject asString].
	(anObject isKindOf: Boolean) ifTrue: [^ 'B' , (anObject ifTrue: ['t'] ifFalse:['f'])].
	(anObject isNil) ifTrue: [^ 'N'].

	"none of the above, so pass by reference"
	^ 'O' , (anORB export: anObject) marshal
! !

!Marshaller class methodsFor: 'marshalling' stamp: 'JF 7/20/2000 23:44'!
unmarshal: aString withORB: anORB
	| typechar data |

	typechar _ aString at: 1.
	data _ aString copyFrom: 2 to: aString size.
	typechar = $O ifTrue: [^ anORB import: data].
	typechar = $Y ifTrue: [^ data asSymbol].
	typechar = $S ifTrue: [^ data].
	typechar = $I ifTrue: [^Integer readFrom: (ReadStream on: data)].
	typechar = $C ifTrue: [^ data at: 1].
	typechar = $B ifTrue: [^ (data at: 1) = $t].
	typechar = $N ifTrue: [^ nil].
	self error: 'Can not unmarshal'
! !


Object subclass: #NameSpace
	instanceVariableNames: 'names '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Network-Remote message passing'!

!NameSpace methodsFor: 'Contents Management' stamp: 'JF 7/18/2000 16:44'!
bind: aString to: anObject
	(self names includesKey: aString)
		ifTrue: [^ false]
		ifFalse: [self names at: aString put: anObject]! !

!NameSpace methodsFor: 'Contents Management' stamp: 'JF 7/18/2000 18:06'!
lookup: aString
	^ self names at: aString ifAbsent: [^nil]! !

!NameSpace methodsFor: 'Contents Management' stamp: 'JF 7/18/2000 16:50'!
rebind: aString to: anObject
	self names at: aString put: anObject.
	^ true! !


!NameSpace methodsFor: 'private-accessing' stamp: 'JF 7/18/2000 16:39'!
names
	^names! !

!NameSpace methodsFor: 'private-accessing' stamp: 'JF 7/18/2000 16:39'!
names: aDictionary
	names _ aDictionary! !


!NameSpace methodsFor: 'initialize-release' stamp: 'JF 7/18/2000 16:46'!
initialize
	self names: Dictionary new! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NameSpace class
	instanceVariableNames: ''!

!NameSpace class methodsFor: 'instance creation' stamp: 'JF 7/18/2000 16:45'!
new
	^ super new initialize! !


Object subclass: #NetworkSkeleton
	instanceVariableNames: 'delegate objectReference orb '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Network-Remote message passing'!
!NetworkSkeleton commentStamp: '<historical>' prior: 0!
A skeleton for remote methods. The skeleton is located at server side, it receives method invocation requests from the stub via the ORB. Arguments are unmarshalled, method is performed on the delegate and return value is marshalled and sent back.!


!NetworkSkeleton methodsFor: 'message handling' stamp: 'JF 7/19/2000 12:43'!
dispatchMessage: aSelector withArgs: args
	"Unmarshal selector and arguments, send the message to the object is was really intended to.
	Marshal the return value and return it" 

	| retval |
	retval _ delegate perform: (aSelector asSymbol) withArguments: (self unmarshal: args).
	^ self marshal: retval! !


!NetworkSkeleton methodsFor: 'accessing' stamp: 'JF 6/30/2000 18:12'!
delegate

	^delegate! !

!NetworkSkeleton methodsFor: 'accessing' stamp: 'JF 6/30/2000 18:13'!
delegate: anObject

	delegate _ anObject! !

!NetworkSkeleton methodsFor: 'accessing' stamp: 'JF 7/3/2000 17:32'!
objectReference
	^objectReference! !

!NetworkSkeleton methodsFor: 'accessing' stamp: 'JF 7/3/2000 17:32'!
objectReference: anOR
	objectReference _ anOR! !

!NetworkSkeleton methodsFor: 'accessing' stamp: 'JF 7/5/2000 18:13'!
orb
	^orb! !

!NetworkSkeleton methodsFor: 'accessing' stamp: 'JF 7/5/2000 18:14'!
orb: anORB
	orb _ anORB! !


!NetworkSkeleton methodsFor: 'converting' stamp: 'JF 7/19/2000 12:27'!
marshal: anObject

	"Marshal a return value. Optimized for self return value"
	anObject == self delegate
		ifTrue:[^ 'T']
		ifFalse:[^ Marshaller marshal: anObject withORB: self orb]! !

!NetworkSkeleton methodsFor: 'converting' stamp: 'JF 7/5/2000 18:10'!
unmarshal: anArgumentArray
	"Unmarshal the array of arguments"

	^ anArgumentArray collect:
		[:element | Marshaller unmarshal: element withORB: self orb].! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NetworkSkeleton class
	instanceVariableNames: ''!

!NetworkSkeleton class methodsFor: 'instance creation' stamp: 'JF 7/3/2000 17:39'!
new
	^ self shouldNotImplement! !

!NetworkSkeleton class methodsFor: 'instance creation' stamp: 'JF 7/18/2000 17:09'!
on: anObject withID: anID withORB: anORB
	^ self basicNew delegate: anObject; objectReference: (LOR to: anObject withID: anID); orb: anORB! !

!NetworkSkeleton class methodsFor: 'instance creation' stamp: 'JF 7/5/2000 18:14'!
on: anObject withORB: anORB
	^ self basicNew delegate: anObject; objectReference: (LOR to: anObject); orb: anORB! !


ProtoObject subclass: #NetworkStub
	instanceVariableNames: 'xxxJFStubOrb xxxJFStubObjectReference '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Network-Remote message passing'!
!NetworkStub commentStamp: '<historical>' prior: 0!
A stub for remote methods. The stub is located at client side, it passes method invocations to the skeleton, via the ORB. Arguments are marshalled and return value is unmarshalled here.!


!NetworkStub methodsFor: 'class membership' stamp: 'JF 7/19/2000 23:46'!
isKindOf: aClass
	"Must be intercepted or ORB>>export will not work correctly."

	(aClass = NetworkStub)
		ifTrue: [^ true].
	(aClass = NetworkSkeleton)
		ifTrue: [^ false].
	^ self doesNotUnderstand: (Message selector: #isKindOf: argument: aClass) ! !


!NetworkStub methodsFor: 'error handling' stamp: 'JF 9/18/2000 17:49'!
doesNotUnderstand: aMessage 
	"Any normal message sent to this object is really intended for another object that is remote
	So we marshal the selector and args and let the ORB pass it over the network.
	We unmarshal the return value given by the orb and return it."

	| retval |

	"Uncomment this for a trace of outgoing messages"
	"Transcript show: '<', aMessage asString, '>';cr."

	retval _ self xxxJFStubOrb passMessage: (aMessage selector asString)
			withArgs: (self xxxJFStubMarshal: aMessage arguments)
			toObject: (self xxxJFStubObjectReference).
	^ self xxxJFStubUnmarshal: retval
! !

!NetworkStub methodsFor: 'error handling' stamp: 'JF 6/30/2000 17:37'!
halt
	"ProtoObject does not implement halt, but it would be nice to have it here."

	Halt signal! !


!NetworkStub methodsFor: 'metalevel' stamp: 'JF 7/6/2000 14:48'!
class
	"does not work!! Bug in Squeak!!"
	self halt.

	^ self doesNotUnderstand: (Message selector: #class).! !


!NetworkStub methodsFor: 'user interface' stamp: 'JF 9/11/2000 16:17'!
inspect
	"If we would redirect 'inspect', the inspector would appear on the remote computer!!
	Still buggy though. Inspectors dont really inspect correctly due to buggy 'class' message"

	Transcript show: 'Inspecting remote object ',self xxxJFStubObjectReference marshal;cr.
	Inspector openOn: self withEvalPane: true! !

!NetworkStub methodsFor: 'user interface' stamp: 'JF 6/30/2000 17:50'!
smartInspect
	"Like inspect, but for collections with only one element, inspects that element"
	^ self inspect! !


!NetworkStub methodsFor: 'converting' stamp: 'JF 9/11/2000 15:56'!
xxxJFStubMarshal: anArgumentArray
	"Marshal the arguments of the message.
	Ugly name to avoid accidentally intercepting a message of the original object."

	^ anArgumentArray collect:
		[:element | Marshaller marshal: element withORB: self xxxJFStubOrb].! !

!NetworkStub methodsFor: 'converting' stamp: 'JF 9/11/2000 15:56'!
xxxJFStubUnmarshal: aString
	"unmarshal the return value. Optimized for self return value
	Ugly name to avoid accidentally intercepting a message of the original object."

	aString = 'T'
		ifTrue: [^ self]
		ifFalse: [^Marshaller unmarshal: aString withORB: self xxxJFStubOrb].! !


!NetworkStub methodsFor: 'private-accessing' stamp: 'JF 7/4/2000 08:16'!
xxxJFStubObjectReference
	"Ugly name to avoid accidentally intercepting a message of the original object."
	^ xxxJFStubObjectReference! !

!NetworkStub methodsFor: 'private-accessing' stamp: 'JF 7/31/2000 15:56'!
xxxJFStubObjectReference: anOR
	"Ugly name to avoid accidentally intercepting a message of the original object."
	xxxJFStubObjectReference _ anOR.! !

!NetworkStub methodsFor: 'private-accessing' stamp: 'JF 7/3/2000 19:00'!
xxxJFStubOrb
	"Ugly name to avoid accidentally intercepting a message of the original object."
	^ xxxJFStubOrb! !

!NetworkStub methodsFor: 'private-accessing' stamp: 'JF 7/3/2000 19:01'!
xxxJFStubOrb: anORB
	"Ugly name to avoid accidentally intercepting a message of the original object."
	xxxJFStubOrb _ anORB! !


!NetworkStub methodsFor: 'optimisation' stamp: 'JF 7/13/2000 13:22'!
yourself
	^ self! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NetworkStub class
	instanceVariableNames: ''!

!NetworkStub class methodsFor: 'instance creation' stamp: 'JF 7/5/2000 18:08'!
fromObjectReference: anOR withORB: anORB
	"ObjectReference should be in unmarshalled form!!"

	^ self basicNew xxxJFStubObjectReference: anOR; xxxJFStubOrb: anORB! !


!NetworkStub class methodsFor: 'patching' stamp: 'JF 7/6/2000 15:06'!
allInstVarNames
	"Patch for inspectors, due to faulty 'class' message"
	^#()! !


Object subclass: #ORB
	instanceVariableNames: 'skeletons stubs exportedObjects importedObjects port inqueue listenProcess listening hasnameservice packets '
	classVariableNames: 'TheORB '
	poolDictionaries: ''
	category: 'Network-Remote message passing'!
!ORB commentStamp: 'JF 9/19/2000 15:04' prior: 0!
Object Request broker. Does all the network interactions (passing messages around over the network)

==== Use of RMP, simple demo: ====

Do the 'serverside' stuff on one VM, 'clientside' on another ( on a *different* computer).
Or ... if you are really lazy, do both in two different workspaces on one VM. BUT do not initialize the ORB and LOR twice!!

Dont forget to fill in the ip address of the server in the clientside code.

- Serverside -
"init ORB and OR and get a ref to the current orb"
ORB initialize.
LOR initialize.
orb _ ORB current.

"Start the name service and get a ref"
orb registerNameService.
ns _ orb lookupLocalNameService.

"Make a servant object"
orig _ Dictionary new: 3.

"Make a name space (named Aargh) to contain the servant (bound to 42)"
ns rebind: 'Aargh' to: NameSpace new.
(ns lookup: 'Aargh') rebind: 42 to: orig.

"By binding an object in the name service, the object is automagically exported"

- Clientside -
"init ORB and OR and get a ref to the current orb"
ORB initialize.
LOR initialize.
orb _ ORB current.

"get a remote ref to the name service on the server"
ns _ orb lookupNameServiceOnHost: '<IP ADRESS OF SERVER>' withPort: 4242.

"get a remote ref to the servant"
stub _ (ns lookup: 'Aargh') lookup: 42.

"Mess around with the servant as though it was a local object"
stub add: ('Whoa' -> Set new).
stub add: (42 -> Set new).
(stub at: 'Whoa') add: 'Yikes'.

"Do a PrintIt on this one"
stub asArray.
!


!ORB methodsFor: 'network - outgoing' stamp: 'JF 9/18/2000 17:46'!
passMessage: aSelector withArgs: anArgumentArray toObject: anOR

	"Transmit a over the network to the remote object indicated in the OR.
	selector and argument array must already be marshalled"

	| socket packet retval |

	packet _ MessagePacket or: anOR selector: aSelector arglist: anArgumentArray.
	socket _ packet sendTo: (NetNameResolver addressForName: anOR hostip) andPort: anOR hostport.

	(socket waitForDataUntil: (Socket deadlineSecs: 120)) ifFalse: [self error: 'No reply from remote ORB!!'].

	retval _ ORBPacket fromSocket: socket.
	socket closeAndDestroy.
	^ retval executeWithORB: self.! !


!ORB methodsFor: 'network - incoming' stamp: 'JF 8/8/2000 16:19'!
dispatchMessage: aSelector withArgs: anArgumentArray toObject: anOR

	"dispatch a message recieved over the network to the local object indicated in the OR.
	selector, argument array and OR are in marshalled form"

	| objectref skel |

	objectref _ LOR unmarshal: anOR.
	skel _ self skeletons at: objectref ifAbsent: [self error: 'Object not exported'].
	^ skel dispatchMessage: aSelector withArgs: anArgumentArray.
 ! !

!ORB methodsFor: 'network - incoming' stamp: 'JF 8/30/2000 16:02'!
handleConnection: aSocket
	"A connection has been made, wait until there is incoming data ( a message)
	and handle. All this in a different process, so we can still recieve other incoming messages"

	| quit |

	quit _ false.
	[[self listening and: [quit not]] whileTrue: [
			(aSocket waitForDataUntil: Socket standardDeadline)
				ifTrue: [self handlePacket: aSocket. quit _ true.]].
		aSocket closeAndDestroy.] fork
! !

!ORB methodsFor: 'network - incoming' stamp: 'JF 9/18/2000 17:48'!
handlePacket: aSocket
	"A packet has arrived on the socket. Read it in and perform the according operation."

	"Right now, we can only receive message packets here"
	|packet|

	packet _ ORBPacket fromSocket: aSocket.

	packets add: packet.

	"Uncomment this for a trace of incoming requests"
	"Transcript show: 'dispatching <',packet selector,' with args', packet args asString, '> to ',packet oref ;cr."

	[|message |
		message _ (self dispatchMessage: packet selector withArgs: packet args toObject: packet oref).
		"Uncomment this for a trace of returned values"
		"Transcript show: 'HandlePacket returning ',message; cr."
		packet _ ReturnPacket withReturnValue: message. ]
	on: Error do:
		[:err |packet _ ErrorPacket withError: err].

	packet sendOn: aSocket.

! !

!ORB methodsFor: 'network - incoming' stamp: 'JF 8/24/2000 16:30'!
listenOn: portnumber
	"Listen for incoming messages. When a connection is made, handle it.
	When I should no longer listen, I clean up after myself."

	| socket |

	self inqueue: (ConnectionQueue portNumber: portnumber queueLength: 6).

	[self listening] whileTrue: [
		socket _ self inqueue getConnectionOrNil.
		socket notNil
			ifTrue: [self handleConnection: socket]
			ifFalse: [(Delay forMilliseconds: 10) wait]].

	self inqueue destroy.
	self listenProcess terminate.! !

!ORB methodsFor: 'network - incoming' stamp: 'JF 7/13/2000 13:07'!
startListening
	"Start listening for incoming messages"

	Transcript show: 'ORB starting to Listen on port', self port asString; cr.
	self listening: true.
	self listenProcess: ([self listenOn: self port] newProcess).
	self listenProcess priority: (Processor highIOPriority).
	self listenProcess resume.! !

!ORB methodsFor: 'network - incoming' stamp: 'JF 7/12/2000 15:42'!
stopListening
	
	self listening: false.
 
! !


!ORB methodsFor: 'initialize-release' stamp: 'JF 8/24/2000 15:04'!
initialize: aPort

 	self skeletons: Dictionary new.
	self stubs: Dictionary new.
	self exportedObjects: Dictionary new.
	self importedObjects: Dictionary new.
	self port: aPort.
	self listening: false.
	self hasNameService: false.
	packets _ OrderedCollection new: 300.! !


!ORB methodsFor: 'accessing' stamp: 'JF 7/3/2000 15:44'!
exportedObjects
	^ exportedObjects! !

!ORB methodsFor: 'accessing' stamp: 'JF 7/3/2000 15:44'!
exportedObjects: aDictionary
	exportedObjects _ aDictionary! !

!ORB methodsFor: 'accessing' stamp: 'JF 8/1/2000 15:13'!
hasNameService
	^ hasnameservice! !

!ORB methodsFor: 'accessing' stamp: 'JF 8/1/2000 15:13'!
hasNameService: aBoolean
	hasnameservice _ aBoolean! !

!ORB methodsFor: 'accessing' stamp: 'JF 7/12/2000 17:41'!
importedObjects
	^ importedObjects! !

!ORB methodsFor: 'accessing' stamp: 'JF 7/12/2000 17:41'!
importedObjects: aDictionary
	importedObjects _ aDictionary! !

!ORB methodsFor: 'accessing' stamp: 'JF 7/10/2000 14:43'!
inqueue
	^inqueue! !

!ORB methodsFor: 'accessing' stamp: 'JF 7/10/2000 14:43'!
inqueue: aConnectionQueue
	inqueue _ aConnectionQueue! !

!ORB methodsFor: 'accessing' stamp: 'JF 7/10/2000 14:42'!
listenProcess
	^listenProcess! !

!ORB methodsFor: 'accessing' stamp: 'JF 7/10/2000 14:42'!
listenProcess: aProcess
	listenProcess _ aProcess! !

!ORB methodsFor: 'accessing' stamp: 'JF 7/12/2000 15:40'!
listening	
	^listening! !

!ORB methodsFor: 'accessing' stamp: 'JF 7/12/2000 15:41'!
listening: aBoolean
	listening _ aBoolean! !

!ORB methodsFor: 'accessing' stamp: 'JF 7/4/2000 10:46'!
port
	^port! !

!ORB methodsFor: 'accessing' stamp: 'JF 7/4/2000 10:46'!
port: aPort
	port _ aPort! !

!ORB methodsFor: 'accessing' stamp: 'JF 6/30/2000 18:03'!
skeletons

	^ skeletons! !

!ORB methodsFor: 'accessing' stamp: 'JF 7/3/2000 15:45'!
skeletons: aDictionary

	skeletons _ aDictionary! !

!ORB methodsFor: 'accessing' stamp: 'JF 7/3/2000 13:03'!
stubs
	^ stubs! !

!ORB methodsFor: 'accessing' stamp: 'JF 7/3/2000 15:45'!
stubs: aDictionary

	stubs _ aDictionary! !


!ORB methodsFor: 'Stubs&Skels Management' stamp: 'JF 7/12/2000 15:51'!
export: anObject
	"I make an object available to the outside world and start listening for incoming
	connections if not already doing so. Returns the objectReference
	If the object is a stub or a skeleton I do nothing, I just return the reference."
	
	(anObject isKindOf: NetworkStub) or: [(anObject isKindOf: NetworkSkeleton)
		ifTrue: [^ anObject objectReference].
	
	(self alreadyExported: anObject)
			ifTrue: [^ self exportedObjects at: anObject]
			ifFalse: [|reference skeleton|
						skeleton _ NetworkSkeleton on: anObject withORB: self.
						reference _ skeleton objectReference.
						self skeletons add: (reference -> skeleton).
						self exportedObjects add: (anObject -> reference).
						self listening ifFalse: [self startListening].
						^ reference]].
! !

!ORB methodsFor: 'Stubs&Skels Management' stamp: 'JF 7/12/2000 17:46'!
import: aLOR

	(self alreadyImported: aLOR)
		ifTrue: [^ self importedObjects at: aLOR]
		ifFalse: [|stub|
			stub _ NetworkStub fromObjectReference: (LOR unmarshal: aLOR) withORB: self.
			importedObjects add: (aLOR -> stub).
			^stub].! !

!ORB methodsFor: 'Stubs&Skels Management' stamp: 'JF 8/1/2000 15:43'!
lookupLocalNameService
	"I return the Name Service local to this ORB"

	^(self skeletons
		at: (LOR  toHost: NetNameResolver localAddressString withPort: self port andID: -1)
		ifAbsent: [self error: 'Name Service not registered']) delegate.! !

!ORB methodsFor: 'Stubs&Skels Management' stamp: 'JF 8/1/2000 15:05'!
lookupNameServiceOnHost: anIP withPort: aPort
	"I return a stub to the Name Service on a remote machine."

	^ NetworkStub fromObjectReference: (LOR toHost: anIP withPort: aPort andID: -1) withORB: self.! !

!ORB methodsFor: 'Stubs&Skels Management' stamp: 'JF 8/1/2000 15:14'!
registerNameService

	"I make a Name Service available to the outside world and start listening for incoming
	connections if not already doing so. 
	Returns true if successful, false if not because service has already been registered."

	| skeleton reference namespace|

	self hasNameService ifTrue: [^ false].

	namespace _ (NameSpace new).

	skeleton _ NetworkSkeleton on: namespace withID: -1 withORB: self.
	reference _ skeleton objectReference.
	self skeletons add: (reference -> skeleton).
	self exportedObjects add: (namespace -> reference).
	self listening ifFalse: [self startListening].
	self hasNameService: true.
	^ true.! !

!ORB methodsFor: 'Stubs&Skels Management' stamp: 'JF 8/30/2000 16:10'!
unexport: anObject
	"I make an exported servant (not stub or skeleton) unavailable to the outside world.
	Might be a good idea if you call this to first remove the object from the naming service
	if it is bound there."

	| reference |

	reference _ self exportedObjects at: anObject ifAbsent: [self error: 'Object not exported'].

	self exportedObjects removeKey: anObject.
	self skeletons removeKey: reference.
! !


!ORB methodsFor: 'testing' stamp: 'JF 7/3/2000 15:48'!
alreadyExported: anObject

	^ self exportedObjects includesKey: anObject! !

!ORB methodsFor: 'testing' stamp: 'JF 7/12/2000 17:42'!
alreadyImported: anObject

	^ self importedObjects includesKey: anObject! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ORB class
	instanceVariableNames: ''!

!ORB class methodsFor: 'instance creation' stamp: 'JF 7/4/2000 10:51'!
current

	TheORB isNil ifTrue:[self error: 'ORB not initalized!!'].
	^ TheORB
! !

!ORB class methodsFor: 'instance creation' stamp: 'JF 7/3/2000 17:39'!
new
	^ self current! !


!ORB class methodsFor: 'initialize-release' stamp: 'JF 7/4/2000 10:47'!
initialize

	self initialize: 4242! !

!ORB class methodsFor: 'initialize-release' stamp: 'JF 7/10/2000 16:33'!
initialize: aPort
	"Start the ORB, listen to the specified port"

	NetNameResolver initializeNetworkIfFail: [self error: 'network initialization failed'].
	SimpleClientSocket initialize.

	TheORB _ self basicNew.
	TheORB initialize: 4242.
	^ TheORB
! !


Object subclass: #ORBPacket
	instanceVariableNames: 'stringRepresentation '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Network-Remote message passing'!

!ORBPacket methodsFor: 'accessing' stamp: 'JF 8/7/2000 14:44'!
stringRepresentation
	^stringRepresentation! !

!ORBPacket methodsFor: 'accessing' stamp: 'JF 8/7/2000 14:43'!
stringRepresentation: aString
	stringRepresentation _ aString! !


!ORBPacket methodsFor: 'network handling' stamp: 'JF 8/7/2000 15:43'!
sendOn: aSocket.
	aSocket sendData: self stringRepresentation.! !

!ORBPacket methodsFor: 'network handling' stamp: 'JF 8/25/2000 13:40'!
sendTo: anAdress andPort: aPort

	| socket |

	socket _ SimpleClientSocket new.
	socket connectTo: anAdress port: aPort.
	(socket waitForConnectionUntil: Socket standardDeadline) ifFalse: [self error: 'Could not connect to remote ORB!!'].
	
	socket sendData: self stringRepresentation.
	^socket! !


!ORBPacket methodsFor: 'operations' stamp: 'JF 8/8/2000 11:43'!
executeWithORB: anORB
	"Called by the ORB after this packet has been received."
	^ self subclassResponsibility ! !


!ORBPacket methodsFor: 'initialize-release' stamp: 'JF 8/7/2000 16:36'!
parseString: aString
	^ self subclassResponsibility ! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ORBPacket class
	instanceVariableNames: ''!

!ORBPacket class methodsFor: 'instance creation' stamp: 'JF 8/7/2000 17:05'!
fromSocket: aSocket
	"Get a packet from a socket."
	| stringrep |
	stringrep _ self getStringifiedPacketFrom: aSocket.
	^ self fromString: stringrep.
! !

!ORBPacket class methodsFor: 'instance creation' stamp: 'JF 8/8/2000 11:35'!
fromString: aString
	"Determine what kind of packet we have here, and instantiate the right subclass"
	| typestring |
	
	typestring _ (aString at: 1) asString.

	typestring = 'M' ifTrue: [^ MessagePacket new parseString: aString].
	typestring = 'R' ifTrue: [^ ReturnPacket new parseString: aString].
	typestring = 'E' ifTrue: [^ ErrorPacket new parseString: aString].
	self error: 'Can not determine packet type'! !


!ORBPacket class methodsFor: 'network handling' stamp: 'JF 8/30/2000 16:00'!
getNumChars: anInteger from: aSocket
	"Data is available from the socket.
	Get a number of characters from the socket, and return them as String"
	|justread totalread characters |

	characters _ String new: anInteger.
	totalread _ 0.
	justread _ aSocket readInto: characters startingAt: totalread + 1.
	[(totalread _ justread + totalread) < anInteger] whileTrue: [
		"[aSocket dataAvailable not] whileTrue: [(Delay forMilliseconds: 10) wait.]."
		[aSocket waitForDataUntil: Socket standardDeadline] whileFalse: [].
		justread _ aSocket readInto: characters startingAt: totalread + 1.].

	^ characters.! !

!ORBPacket class methodsFor: 'network handling' stamp: 'JF 8/7/2000 17:05'!
getStringifiedPacketFrom: aSocket
	"Data is available from the socket. Extract a data 'packet'"
	| lengthstr packetlength |

	lengthstr _ self getNumChars: 3 from: aSocket.
	packetlength _ self decodeArgumentLength: lengthstr.

	^ self getNumChars: packetlength from: aSocket.! !


!ORBPacket class methodsFor: 'encoding-decoding' stamp: 'JF 8/7/2000 17:16'!
decodeArgumentLength: aString
	"Dencode a string of 3 characters, base 256, into an integer."

^	(((aString at: 1) asciiValue) * 65536) + (((aString at: 2) asciiValue) * 256) + ((aString at: 3) asciiValue)! !

!ORBPacket class methodsFor: 'encoding-decoding' stamp: 'JF 8/7/2000 17:17'!
encodeArgumentLength: anInteger
	"Encode an integer length into a string of 3 characters, base 256
	This implies the largest encodeable number = 2 raisedTo: 24  (= 16Megabytes)
	It should be big enough for now."

	| integercode running|

	anInteger > (2 raisedTo: 24) ifTrue: [
		self halt: 'Can not encode this integer'].

	running _ anInteger.
	
	integercode _ String new: 3.
	running > 65535 ifTrue: [|quot|
		quot _ running // 65536.
		running _ running - (quot * 65536).
		integercode at: 1 put: (Character value: quot).].
	running > 255 ifTrue: [|quot|
		quot _ running // 256.
		running _ running - (quot * 256).
		integercode at: 2 put: (Character value: quot).].
	integercode at: 3 put: (Character value: running).

	^integercode.! !

!ORBPacket class methodsFor: 'encoding-decoding' stamp: 'JF 8/7/2000 17:17'!
prependLength: aString
	^ (self encodeArgumentLength: aString size), aString.! !

!ORBPacket class methodsFor: 'encoding-decoding' stamp: 'JF 8/7/2000 17:53'!
prependTypeAndLength: aString
	^ (self encodeArgumentLength: (aString size + 1)),self typeString, aString.! !

!ORBPacket class methodsFor: 'encoding-decoding' stamp: 'JF 8/7/2000 17:54'!
typeString
	^ self subclassResponsibility! !


ORBPacket subclass: #ErrorPacket
	instanceVariableNames: 'remoteErrorText '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Network-Remote message passing'!

!ErrorPacket methodsFor: 'initialize-release' stamp: 'JF 8/8/2000 11:50'!
parseString: aString
	self remoteErrorText: (aString copyFrom: 2 to: aString size).! !

!ErrorPacket methodsFor: 'initialize-release' stamp: 'JF 8/8/2000 14:35'!
withError: anError
	self stringRepresentation:
		(self class prependTypeAndLength: (anError asString ,' with text: ', anError messageText)).! !


!ErrorPacket methodsFor: 'operations' stamp: 'JF 8/8/2000 11:51'!
executeWithORB: anORB
	^ RemoteError signal: (self remoteErrorText)! !


!ErrorPacket methodsFor: 'accessing' stamp: 'JF 8/8/2000 11:50'!
remoteErrorText
	^remoteErrorText! !

!ErrorPacket methodsFor: 'accessing' stamp: 'JF 8/8/2000 11:50'!
remoteErrorText: anErrorText
	remoteErrorText _ anErrorText! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ErrorPacket class
	instanceVariableNames: ''!

!ErrorPacket class methodsFor: 'encoding-decoding' stamp: 'JF 8/8/2000 11:26'!
typeString
	^ 'E'! !


!ErrorPacket class methodsFor: 'instance creation' stamp: 'JF 8/8/2000 14:25'!
withError: anError
	^ super new withError: anError.! !


ORBPacket subclass: #MessagePacket
	instanceVariableNames: 'oref selector args '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Network-Remote message passing'!

!MessagePacket methodsFor: 'initialize-release' stamp: 'JF 8/7/2000 17:18'!
extractArguments: aString

	| numargs retval argnum index end |
	
	numargs _ (aString at: 1) asciiValue.
	retval _ Array new: numargs.
	
	numargs = 0 ifTrue: [^ retval].

	argnum _ 1.
	index _ 2.
	end _ aString size.

	[index < end] whileTrue: [| argsize arg |
		argsize _ self class decodeArgumentLength: (aString copyFrom: index to: (index _ index + 3)).
		arg _ aString copyFrom: index to: (index _ index + argsize) - 1.
		retval at: argnum put: arg.
		argnum _ argnum + 1].

	^ retval.! !

!MessagePacket methodsFor: 'initialize-release' stamp: 'JF 8/7/2000 18:03'!
or: anOR selector: aSelector arglist: anArgArray
	"Create a message packet. no more than 256 args are possible for a message!!"

	| arglist data |

	arglist _ anArgArray
				inject: ''
				into: [:arguments :element | arguments _ arguments, (self class prependLength: element)].
	data _ anOR marshal, String crlf,
				aSelector, String crlf,
				"!!no more than 256 args"
				(String with: (Character value: anArgArray size)),
				arglist.

	self stringRepresentation: (self class prependTypeAndLength: data).! !

!MessagePacket methodsFor: 'initialize-release' stamp: 'JF 8/7/2000 17:59'!
parseString: aString
	|orindex selindex|

	orindex _ aString findString: String crlf.
	self oref: (aString copyFrom: 2 to: orindex - 1).
	selindex _ aString findString: String crlf startingAt: orindex + 2.
	self selector: (aString copyFrom: orindex + 2 to: selindex - 1).
	self args: (self extractArguments: (aString copyFrom: selindex + 2 to: aString size)).
! !


!MessagePacket methodsFor: 'accessing' stamp: 'JF 8/7/2000 16:34'!
args
	^args! !

!MessagePacket methodsFor: 'accessing' stamp: 'JF 8/7/2000 16:35'!
args: anArgArray
	args _ anArgArray! !

!MessagePacket methodsFor: 'accessing' stamp: 'JF 8/7/2000 16:42'!
oref
	^oref! !

!MessagePacket methodsFor: 'accessing' stamp: 'JF 8/7/2000 16:42'!
oref: anOR
	oref _ anOR! !

!MessagePacket methodsFor: 'accessing' stamp: 'JF 8/7/2000 16:34'!
selector
	^selector! !

!MessagePacket methodsFor: 'accessing' stamp: 'JF 8/7/2000 16:34'!
selector: aString
	selector _ aString! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

MessagePacket class
	instanceVariableNames: ''!

!MessagePacket class methodsFor: 'encoding-decoding' stamp: 'JF 8/7/2000 17:55'!
typeString
	^ 'M'! !


!MessagePacket class methodsFor: 'instance creation' stamp: 'JF 8/7/2000 14:54'!
or: anOR selector: aSelector arglist: anArgArray.
	^ super new or: anOR selector: aSelector arglist: anArgArray. ! !


Error subclass: #RemoteError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Network-Remote message passing'!


ORBPacket subclass: #ReturnPacket
	instanceVariableNames: 'returnValue '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Network-Remote message passing'!

!ReturnPacket methodsFor: 'initialize-release' stamp: 'JF 8/7/2000 18:04'!
parseString: aString

	self returnValue: (aString copyFrom: 2 to: aString size).! !

!ReturnPacket methodsFor: 'initialize-release' stamp: 'JF 8/7/2000 18:03'!
withReturnValue: aString
	self stringRepresentation: (self class prependTypeAndLength: aString).! !


!ReturnPacket methodsFor: 'accessing' stamp: 'JF 8/7/2000 16:59'!
returnValue
	^ returnValue.! !

!ReturnPacket methodsFor: 'accessing' stamp: 'JF 8/7/2000 17:00'!
returnValue: aString
	returnValue _ aString.! !


!ReturnPacket methodsFor: 'operations' stamp: 'JF 8/8/2000 11:44'!
executeWithORB: anORB
	^ self returnValue.! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ReturnPacket class
	instanceVariableNames: ''!

!ReturnPacket class methodsFor: 'initialize-release' stamp: 'JF 8/7/2000 16:59'!
withReturnValue: aString
	^ super new withReturnValue: aString! !


!ReturnPacket class methodsFor: 'encoding-decoding' stamp: 'JF 8/7/2000 17:55'!
typeString
	^ 'R'! !

LOR initialize!
ORB initialize!